# Ogre::D3D9HardwareOcclusionQuery Class Reference

This is a class that is the DirectX9 implementation of hardware occlusion testing. More...

`#include <OgreD3D9HardwareOcclusionQuery.h>`

Inheritance diagram for Ogre::D3D9HardwareOcclusionQuery:

List of all members.

## Public Member Functions

| D3D9HardwareOcclusionQuery (IDirect3DDevice9 *pD3DDevice)
| Default object constructor.
| ~D3D9HardwareOcclusionQuery ()
| Object destructor.
void | beginOcclusionQuery ()
| Starts the hardware occlusion query Simple usage: Create one or more OcclusionQuery object one per outstanding query or one per tested object OcclusionQuery* m_pOcclusionQuery; createOcclusionQuery( &m_pOcclusionQuery ); In the rendering loop: Draw all occluders m_pOcclusionQuery->startOcclusionQuery(); Draw the polygons to be tested m_pOcclusionQuery->endOcclusionQuery();.
void | endOcclusionQuery ()
| Ends the hardware occlusion test.
bool | pullOcclusionQuery (unsigned int *NumOfFragments, const HW_OCCLUSIONQUERY flag=HWOCCLUSIONQUERY_FLUSH)
| Pulls the hardware occlusion query too see if there is a result.
unsigned int | getLastQuerysPixelcount ()
| Let's you get the last pixel count with out doing the hardware occlusion test.
bool | isStillOutstanding (void)
void | setSkipRate (int skip)
| Remarks This function allows you to set how often the hardware occlusion query is sent to the driver if you set it to 0 every hardware occlusion test is actually made.
int | getSkipRate ()
virtual bool | HardwareOcclusionQuery::isStillOutstanding (void)=0
| Lets you know when query is done, or still be processed by the Hardware.

## Protected Attributes

unsigned int | mPixelCount
IDirect3DQuery9 * | mpQuery
IDirect3DDevice9 * | mpDevice
int | mSkipCounter
int | mSkipInterval
bool | mHasOcclusionSupport
bool | mIsQueryResultStillOutstanding

## Detailed Description

This is a class that is the DirectX9 implementation of hardware occlusion testing.

Author:
  Lee Sandberg, email lee@abcmedia.se

Updated on 12/7/2004 by Chris McGuirk Updated on 4/8/2005 by Tuan Kuranes email: tuan.kuranes@free.fr

Definition at line 50 of file OgreD3D9HardwareOcclusionQuery.h.

## Constructor & Destructor Documentation

Ogre::D3D9HardwareOcclusionQuery::D3D9HardwareOcclusionQuery | ( | IDirect3DDevice9 * | pD3DDevice | ) |

| Default object constructor.

Ogre::D3D9HardwareOcclusionQuery::~D3D9HardwareOcclusionQuery | ( |  | ) |

| Object destructor.

## Member Function Documentation

void Ogre::D3D9HardwareOcclusionQuery::beginOcclusionQuery | ( |  | ) | `[virtual]`

Starts the hardware occlusion query Simple usage: Create one or more OcclusionQuery object one per outstanding query or one per tested object OcclusionQuery* m_pOcclusionQuery; createOcclusionQuery( &m_pOcclusionQuery ); In the rendering loop: Draw all occluders m_pOcclusionQuery->startOcclusionQuery(); Draw the polygons to be tested m_pOcclusionQuery->endOcclusionQuery();.

Results must be pulled using: UINT m_uintNumberOfPixelsVisable; pullOcclusionQuery( &m_dwNumberOfPixelsVisable ); You may not get the result directly after the first pass or frame. Objects not visible must be tested every frame, visible objects may be tested less frequently.

Implements Ogre::HardwareOcclusionQuery.

void Ogre::D3D9HardwareOcclusionQuery::endOcclusionQuery | ( |  | ) | `[virtual]`

| Ends the hardware occlusion test. Implements Ogre::HardwareOcclusionQuery.

unsigned int Ogre::D3D9HardwareOcclusionQuery::getLastQuerysPixelcount | ( |  | ) | `[virtual]`

Let's you get the last pixel count with out doing the hardware occlusion test.

Returns:
  The last fragment count from the last test. Remarks This function won't give you new values, just the old value.

Implements Ogre::HardwareOcclusionQuery.

Definition at line 75 of file OgreD3D9HardwareOcclusionQuery.h.

References mPixelCount.

int Ogre::D3D9HardwareOcclusionQuery::getSkipRate | ( |  | ) | `[virtual]`

| Implements Ogre::HardwareOcclusionQuery. Definition at line 93 of file OgreD3D9HardwareOcclusionQuery.h. References mSkipInterval.

virtual bool Ogre::HardwareOcclusionQuery::HardwareOcclusionQuery::isStillOutstanding | ( | void |  | ) | `[pure virtual, inherited]`

Lets you know when query is done, or still be processed by the Hardware.

Returns:
  true if query isn't finished.

bool Ogre::D3D9HardwareOcclusionQuery::isStillOutstanding | ( | void |  | ) |

bool Ogre::D3D9HardwareOcclusionQuery::pullOcclusionQuery | ( | unsigned int * | NumOfFragments,
|  | const HW_OCCLUSIONQUERY | flag = HWOCCLUSIONQUERY_FLUSH
| ) | `[virtual]`

Pulls the hardware occlusion query too see if there is a result.

Return values:

  NumOfFragments | will get the resulting number of fragments.

Returns:
  True if success or false if not. In DX9 mode specifying OCCLUSIONQUERY_FLUSH as the flag, will case the driver to flush whatever API calls are batched. In OpenGL mode it makes no difference if you specify OCCLUSIONQUERY_FLUSH or OCCLUSIONQUERY_NOFLUSH.

Implements Ogre::HardwareOcclusionQuery.

void Ogre::D3D9HardwareOcclusionQuery::setSkipRate | ( | int | skip | ) | `[virtual]`

Remarks This function allows you to set how often the hardware occlusion query is sent to the driver if you set it to 0 every hardware occlusion test is actually made.

If you set it to 1 only the half of your queries are sent 2 will result in 25% of all queries to factually be sent. This functionality is here because this class can keep track on visible and none visible objects for you. Once you you set the SkipRate for any hardware occlusion instance it effects all others.

Implements Ogre::HardwareOcclusionQuery.

Definition at line 92 of file OgreD3D9HardwareOcclusionQuery.h.

References mSkipInterval.

## Member Data Documentation

bool Ogre::D3D9HardwareOcclusionQuery::mHasOcclusionSupport `[protected]`

| Definition at line 105 of file OgreD3D9HardwareOcclusionQuery.h.

bool Ogre::D3D9HardwareOcclusionQuery::mIsQueryResultStillOutstanding `[protected]`

| Definition at line 106 of file OgreD3D9HardwareOcclusionQuery.h.

IDirect3DDevice9* Ogre::D3D9HardwareOcclusionQuery::mpDevice `[protected]`

| Definition at line 102 of file OgreD3D9HardwareOcclusionQuery.h.

unsigned int Ogre::D3D9HardwareOcclusionQuery::mPixelCount `[protected]`

| Definition at line 100 of file OgreD3D9HardwareOcclusionQuery.h. Referenced by getLastQuerysPixelcount().

IDirect3DQuery9* Ogre::D3D9HardwareOcclusionQuery::mpQuery `[protected]`

| Definition at line 101 of file OgreD3D9HardwareOcclusionQuery.h.

int Ogre::D3D9HardwareOcclusionQuery::mSkipCounter `[protected]`

| Definition at line 103 of file OgreD3D9HardwareOcclusionQuery.h.

int Ogre::D3D9HardwareOcclusionQuery::mSkipInterval `[protected]`

| Definition at line 104 of file OgreD3D9HardwareOcclusionQuery.h. Referenced by getSkipRate(), and setSkipRate().

The documentation for this class was generated from the following file:

- OgreD3D9HardwareOcclusionQuery.h

Copyright © 2000-2005 by The OGRE Team
Last modified Sun Nov 20 12:45:08 2005